#include <fcntl.h>
#include <ioctl.h>
#include <limits.h>
#include <mintbind.h>
#include <osbind.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "misc.h"
#include "types.h"

WORD Shel_do_read(char *name,char *tail) {
	char pname[30];
	_DTA *olddta,newdta;
	WORD retval;
	
	olddta = Fgetdta();
	Fsetdta(&newdta);
	
	sprintf(pname,"u:\\proc\\*.%03d",Pgetpid());
	if(Fsfirst(pname,0) == 0) {
		LONG fd;
		
		sprintf(pname,"u:\\proc\\%s",newdta.dta_name);
		
		if((fd = Fopen(pname,O_RDONLY)) >= 0) {
			struct __ploadinfo li;
			
			li.fnamelen = 128;
			li.cmdlin = tail;
			li.fname = name;
			
			Fcntl((WORD)fd,&li,PLOADINFO);
			Fclose((WORD)fd);
			retval = 1;
		}
		else {
			retval = 0;
		};
		
	}
	else {
		retval = 0;
	};

	Fsetdta(olddta);
	
	return retval;
}

/*0x0078 shel_read*/

void	Shel_read(AES_PB *apb) {
	apb->int_out[0] = Shel_do_read((char *)apb->addr_in[0],(char *)apb->addr_in[1]);
}


WORD Shel_do_write(WORD ex,WORD gr,WORD cr, char *path, char *cmnd) {
	WORD r = 0;
	char  *tmp,*ddir,*envir;
	char  oldpath[128];
	char  exepath[128];			
	void  **extnd;

	(void)cr;
	extnd = (void**)path;
	ddir = NULL;
	envir = NULL;		
	
	if ( ex & 0xff00) /* should we use extended info? */
	{
		path = extnd[0];

/*		if ( ex & (1 << 8))
			v_Psetlimit = extnd[ 1];
		if ( ex & (1 << 9))
			v_Prenice = extnd[ 2];
*/
 		if ( ex & (1 << 10))
			ddir = extnd[ 3];

		if ( ex & (1 << 11))
			envir = extnd[ 4];
	}	

	ex &= 0xff;

	if ( ex == 0)	/* - run application */
	{
		tmp = strrchr( path, '.');
		if ( !tmp) tmp = "";

	/* use enviroment GEMEXT, TOSEXT, and ACCEXT. */
   		if ( stricmp( tmp, ".app") == 0 || stricmp( tmp, ".prg") == 0)
			ex = 1, gr = 1;
		else if ( stricmp( tmp, ".acc") == 0)
			gr = 3;
		else 
			ex = 1, gr = 0;
	}
	
	switch ( ex)
	{
	case 0: 	/* - run application */
		/* we just did take care of this case */
		break;
			
	case 1: /* - run another application in GEM or TOS mode */
		if ( gr == 1)
		{
			Dgetpath(oldpath,0);

			strcpy( exepath, path);
			tmp = exepath;
			if ( ddir)
				Misc_setpath( ddir);
			else
			{
				tmp = strrchr( exepath,'\\');
				if ( tmp)
				{
					*tmp = 0;
					Misc_setpath( exepath);
					tmp++;
				}
				else 
					tmp = exepath;
			}
			r = Pexec( 100, tmp, cmnd, envir);
			if ( r < 0) r = 0;

			Misc_setpath( oldpath);
		}
		else if ( gr == 0)
		{
			/* we can't yet start TOS programs */
		}
		break;
		
	case 3: /* - run an accessory */
		break;
		
	case 4: /* - set shutdown mode */
	case 5: /* - resolution change */
	case 7: /* - send message to all processes */
	case 8: /* - AES environment */
    case 9: /* - I know about: bit 0: AP_TERM */
	case 10: /* - send message to the AES */
	default:
		;
	}
	
	return r;
}


/****************************************************************************
 * Shel_write                                                               *
 *  0x0079 shel_write().                                                    *
 ****************************************************************************/
void              /*                                                        */
Shel_write(       /*                                                        */
AES_PB *apb)      /* AES parameter block.                                   */
/****************************************************************************/
{
	apb->int_out[0] = 
	Shel_do_write( apb->int_in[0], apb->int_in[1], apb->int_in[2],
		(char *)apb->addr_in[0], (char *)apb->addr_in[1]);
		
	if (apb->int_out[0] == 0) {
		fprintf(stderr,"shel_write(%d,%d,%d,\n\r%s,\n\r%s)\r\n", 
		        apb->int_in[0],apb->int_in[1],apb->int_in[2],
		        (char *)apb->addr_in[0],(char *)apb->addr_in[1]+1);
	}
}

/****************************************************************************
 * Shel_do_find                                                             *
 *  Implementation of shel_find().                                          *
 ****************************************************************************/
WORD              /* 0 if the file was not found or 1.                      */
Shel_do_find(     /*                                                        */
char *buf)        /* Buffer where the filename is given and full path       */
                  /* returned.                                              */
/****************************************************************************/
{
	char  name[128];
 	char tail[128], *p, *q;
	XATTR xa;
	
	strcpy(name,buf);
	
	/* we start by checking if the file is in out path */
	
	if(Fxattr(0,buf,&xa) == 0)  {
	/* check if we were passed an absolute path (rather simplistic)
	 * if this was the case, then _don't_ concat name on the path */
	 	if (!((name[0] == '\\') ||
	 	     (name[0] && (name[ 1] == ':')))) {
			Dgetpath(buf,0);
			strcat(buf, "\\");
			strcat(buf, name);
		};
		
		return 1;
	}

	Shel_do_read( buf, tail);
	p = strrchr( buf, '\\');
	if ( p)		
	{
		strcpy( p+1, name);
		if( Fxattr(0, buf, &xa) == 0) 
			return 1;
	
		q = strrchr( name, '\\');
		if ( q)
		{
			strcpy( p, q);
			if( Fxattr(0, buf, &xa) == 0) 
				return 1;
			else
				; /* <--search the PATH enviroment */
		}
	}
		
	return 0;
}

/****************************************************************************
 * Shel_find                                                                *
 *  0x007c shel_find().                                                     *
 ****************************************************************************/
void              /*                                                        */
Shel_find(        /*                                                        */
AES_PB *apb)      /* AES parameter block.                                   */
/****************************************************************************/
{
	apb->int_out[0] = Shel_do_find((char *)apb->addr_in[0]);
}
